/* 
 * hilbert-interval.C
 */

#include <iostream.h>
#include <iomanip.h>        // setprecision() Τ
#include <IntegerVector.h>  // ʬΥ٥ȥ ipvt
#include <IntervalMatrix.h> // ֱ黻
#include "lu1-interval.h"   // decomp1(), solve1()

main()
{
    int i, j, n;
    INTERVAL one, s, cond;

    cout << setprecision(17);

    cout << "n=";
    cin  >> n;

    // ֤ʬȤ٥ȥ롢Ѱ
    INTERVAL_MATRIX H(n,n);
    INTERVAL_VECTOR x(n);
    INTERVAL_VECTOR b(n);
    INTERVAL_VECTOR work(n);
    INTEGER_VECTOR  ipvt(n);

    // Hilbert 
    one = 1.0;
    for (i = 1; i <= n; i++)
	for (j = 1; j <= n; j++)
	    H(i,j) = one / (i + j - 1);
    // βƤƤ顢ϢΩ1 H x = b αդ׻
    for (i = 1; i <= n; i++)
	x(i) = 1.0;
    b = H * x;

    // x, H, b ɽ
    cout << "β x=" << endl << x << endl;
    cout << "ҥ٥ȹ H=" << endl << H << endl;
    cout << "b=H x=" << endl;
    for (i = 1; i <= n; i++)
      cout << "b(" << i << ")=" << b(i) << endl;

    // LU ʬ ( Gauss õˡˤ)
    decomp1(n, H, cond, ipvt, work);

    // ɾ
    cout << "condition number=" << Sup(cond) << endl;

    solve1(n, H, b, ipvt);
    for (i = 1; i <= n; i++)
      cout << "x(" << i << ")=" << b(i) << "\t" << Diam(b(i)) << endl;
}
